
;**************************************************************************************
;   Discription: String input function	  					      *
;                       							      *
;   Macro name\Input: Input x,y,color,font,lenght,string       	 		      *
;					  					      *
;   Output:				  					      *
;	String into The string you specified			  		      *
;**************************************************************************************

Input MACRO
	move.w \1,d0 ; x
	move.w \2,d1 ; y
	move.w \3,d2 ; color
	move.w \4,d3 ; font
	move.b \5,d4 ; lenght
	bsr Input_code
	Endm

;*******************************************

Save_Screen:
	clr.l d0
	movem.l d0/a0-a1,-(a7)
	lea LCD_MEM,a0
	lea Screen(pc),a1
	move.w #3839,d0
Save_Screenloop1:	
	move.b (a0)+,(a1)+
	dbra.w d0,Save_Screenloop1
	movem.l (a7)+,d0/a0-a1
	rts

;******************************************

Put_Screen:
	movem.l d0/a0-a1,-(a7)
	lea LCD_MEM,a0
	lea Screen(pc),a1
	move.w #3839,d0
Put_Screenloop1:	
      	move.b (a1)+,(a0)+
	dbra.w d0,Put_Screenloop1
	movem.l (a7)+,d0/a0-a1
	rts

;******************************************

Input_code:
	move.l a0,-(a7)
	jsr cprgmsw::deinit_getkey
	move.b #0,Position
	move.w d0,Inputx
	move.w d1,Inputy
	move.b d4,Inputlenght
	bsr Save_Screen
	move.b #95,(a0)
	move.b #0,1(a0) 
	bsr Put_String
mainloop1:
	jsr cprgmsw::getkey2
	cmp.w #0,d0
	beq mainloop1
	cmp.b #257,d0
	bne TestPos
	cmp.b #0,Position
	beq PutString
	sub.l #1,a0
	move.b #95,(a0)
	move.b #0,1(a0)
	sub.b #1,Position
	bra PutString
TestPos:
	cmp.b #13,d0
	beq mainlbl1
	move.b Position,d1
	cmp.b Inputlenght,d1
	bge mainloop1
	cmp.w #128,d0
	bgt mainloop1
	add.b #1,Position
	move.b d0,(a0)+
	move.b Position,d1
	cmp.b Inputlenght,d1
	bge EndString
	move.b #95,(a0)
	move.b #0,1(a0)
	bra PutString
EndString:
	move.b #0,(a0)
PutString:
	bsr Put_Screen
	bsr Put_String
	bra mainloop1
mainlbl1:
	cmp.b #0,Position
	beq mainloop1
	bsr Put_Screen
	move.b #0,(a0)
	jsr cprgmsw::init_getkey
	move.l (a7)+,a0
	rts

Put_String:
	movem.l d0-d7/a0-a6,-(a7)
	move.w d3,-(a7)
	jsr	doorsos::FontSetSys
	add	#2,a7
	move.w	d2,-(a7)
	clr d0
	move.b Position,d0 ; puts the string
	sub.l   d0,a0
	move.l  a0,-(a7)
	add.l   d0,a0
	move.w	Inputy,-(a7)
	move.w	Inputx,-(a7)
	jsr	doorsos::DrawStrXY
	add	#10,a7
	movem.l (a7)+,d0-d7/a0-a6
	rts

;******************************************

Position dc.b 0
Inputx dc.w 0
Inputy dc.w 0
Inputlenght dc.b 0
Screen ds.b 3841
